



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL 5.6 新参数对binlog日志量的优化</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL 5.6 新参数对binlog日志量的优化</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 00:54:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>数据库版本：5.6.*</p>
<h2>1.row日志image类型</h2>
<p>参数<a href="http://www.itbaofeng.com/?tag=binlog_row_image" rel="external nofollow noreferrer">binlog_row_image</a> 控制着这种image类型，默认为FULL（log all columns），即记录before&amp;after images。<br />该参数还有两种，minimal和noblob，minimal表示只记录after更改后的值，并且如果有主键或者非空唯一索引，则只以该字段作为where条件判断；noblob同full，只是不记录blob、text列。</p>
<h2>2.binlog日志</h2>
<p>对于insert则没有什么好说的，我们主要重点关注一下update和delete操作。</p>
<p><strong><a href="http://www.itbaofeng.com/?tag=binlog_row_image" rel="external nofollow noreferrer">binlog_row_image</a>=full的情况下</strong>，对于update和delete所有的表（包含带有主键、非空唯一索引，唯一索引，没有索引）产生的binlog均一致，binlog情况如下：</p>
<ol><li><code>--建表语句</code></li>
<li><code>CREATE TABLE `pk_test`(</code></li>
<li><code>`id` bigint(20) NOT NULL,</code></li>
<li><code>`username` varchar(30) NOT NULL,</code></li>
<li><code>  PRIMARY KEY (`id`)</code></li>
<li><code>) ENGINE=InnoDB DEFAULT CHARSET=utf8;</code></li>
<li><code>insert into pk_test values (1,2);</code></li>
<li><code>insert into pk_test values (2,2);</code></li>
<li><code>commit;</code></li>
<li><code></code></li>
<li><code>show master statusG;--记录binlog文件和pos</code></li>
<li><code></code></li>
<li><code>deletefrom pk_test where id =1;</code></li>
<li><code>update pk_test set username='3';</code></li>
<li><code>commit；</code></li>
<li><code>mysqlbinlog --no-defaults -v --start-position=637945822/mysqllog/3307/binlog/mysql-bin.000001| more</code></li>
<li><code></code></li>
<li><code>### DELETE FROM `baofeng`.`pk_test`</code></li>
<li><code>### WHERE</code></li>
<li><code>###   @1=1</code></li>
<li><code>###   @2='2'</code></li>
<li><code>.....</code></li>
<li><code>### UPDATE `baofeng`.`pk_test`</code></li>
<li><code>### WHERE</code></li>
<li><code>###   @1=2</code></li>
<li><code>###   @2='2'</code></li>
<li><code>### SET</code></li>
<li><code>###   @1=2</code></li>
<li><code>###   @2='3'</code></li></ol>
<p>从上面我们可以看到，在默认为FULL的binlog_row_image下，无论表有没有主键、唯一索引，全部按照全表字段作为条件，且update会更新全部字段。</p>
<p>binlog_row_image=minimal的情况下：</p>
<ol><li><code>--建表语句</code></li>
<li><code>CREATE TABLE `ui_test`(</code></li>
<li><code>`id` bigint(20) NOT NULL,</code></li>
<li><code>`username` varchar(30) NOT NULL,</code></li>
<li><code>  UNIQUE  (`id`)</code></li>
<li><code>) ENGINE=InnoDB DEFAULT CHARSET=utf8;</code></li>
<li><code></code></li>
<li><code>CREATE TABLE `ui_test_null`(</code></li>
<li><code>`id` bigint(20),</code></li>
<li><code>`username` varchar(30) NOT NULL,</code></li>
<li><code>  UNIQUE  key (`id`)</code></li>
<li><code>) ENGINE=InnoDB DEFAULT CHARSET=utf8;</code></li>
<li><code></code></li>
<li><code>CREATE TABLE `null_test`(</code></li>
<li><code>`id` bigint(20),</code></li>
<li><code>`username` varchar(30) NOT NULL</code></li>
<li><code>) ENGINE=InnoDB DEFAULT CHARSET=utf8;</code></li>
<li><code></code></li>
<li><code>insert into pk_test values (1,2);</code></li>
<li><code>insert into ui_test values (1,2);</code></li>
<li><code>insert into ui_test_null values (1,2);</code></li>
<li><code>insert into null_test values (1,2);</code></li>
<li><code>commit;</code></li>
<li><code></code></li>
<li><code>update pk_test set username='4';</code></li>
<li><code>deletefrom pk_test;</code></li>
<li><code>deletefrom ui_test;</code></li>
<li><code>deletefrom ui_test_null;</code></li>
<li><code>update null_test set username='4';</code></li>
<li><code>deletefrom null_test;</code></li>
<li><code></code></li>
<li><code>### UPDATE `baofeng`.`pk_test`</code></li>
<li><code>### WHERE</code></li>
<li><code>###   @1=1</code></li>
<li><code>### SET</code></li>
<li><code>###   @2='4'</code></li>
<li><code>....</code></li>
<li><code>### DELETE FROM `baofeng`.`pk_test`</code></li>
<li><code>### WHERE</code></li>
<li><code>###   @1=1</code></li>
<li><code>.....</code></li>
<li><code>### DELETE FROM `baofeng`.`ui_test`</code></li>
<li><code>### WHERE</code></li>
<li><code>###   @1=1</code></li>
<li><code>.....</code></li>
<li><code>### DELETE FROM `baofeng`.`ui_test_null`</code></li>
<li><code>### WHERE</code></li>
<li><code>###   @1=1</code></li>
<li><code>###   @2='2'</code></li>
<li><code>.....</code></li>
<li><code>### UPDATE `baofeng`.`null_test`</code></li>
<li><code>### WHERE</code></li>
<li><code>###   @1=1</code></li>
<li><code>###   @2='2'</code></li>
<li><code>### SET</code></li>
<li><code>###   @2='4'</code></li>
<li><code>.....</code></li>
<li><code>### DELETE FROM `baofeng`.`null_test`</code></li>
<li><code>### WHERE</code></li>
<li><code>###   @1=1</code></li>
<li><code>###   @2='2'</code></li></ol>
<p>从上面的例子可以看到，当binlog_row_image=minimal的情况下，where条件只有主键或不为空的唯一索引，且只会更新被改变的字段。</p>
<h2>3.总结：</h2>
<p>在上面的测试我们可以看到，如果采用minimal格式，将减少主键和非空唯一索引表的before值，以及减少所有表update的after未被改变的值。<br /> 从效率上来说，减少了网络传输以及加快了update的效率。</p>
<p>参考资料：<br /><a href="https://dev.mysql.com/doc/refman/5.6/en/replication-options-binary-log.html#sysvar_binlog_row_image" rel="external nofollow noreferrer">https://dev.mysql.com/doc/refman/5.6/en/replication-options-binary-log.html#sysvar_binlog_row_image</a></p>
<p><img referrerpolicy="no-referrer"src="http://yarpp.org/pixels/62e5b64add04a9b150eb3b2b0f98f20c" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93n41gq.html">安装 mbed os 开发环境yotta</a>
		</li>
						<li><a href="https://www.batexi.com/a/495d2leq.html">Java内存分配及变量存储位置实例讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdkr0k8.html">1行代码，删除svn文件夹</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmjorl9.html">SQL在指定列后添加新的列</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xgw1w9.html">使用JavaMail发送邮件和接受邮件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjl4479.html">JQuery  补充</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojjdglq.html">Java、PHP训练场地选择成都传祺播客</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j26l38.html">struts2&period;1&period;6教程九、文件上传下载（了解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4xddq.html">nodejs服务实现反向代理，解决本地开发接口请求跨域问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mgdpm8.html">About A Scam</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv21jgj9.html">Nginx&plus;Keepalived（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oej618.html">洛谷模拟NOIP考试反思</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvr5338.html">Ubuntu编译安装配置Redis以及基本使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj0wl0q.html">python第三十四课&mdash;&mdash;1&period;匿名函数的定义和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvv6rdq.html">EMERGENCY&excl; EUREKA MAY BE INCORRECTLY CLAIMING INSTANCES ARE UP WHEN THEY&amp;&num;39&semi;RE NOT&period; RENEWALS ARE LESSER THAN THRESHOLD AND HENCE THE INSTANCES ARE NOT BEING EXPIRED JUST TO BE SAFE&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em5emk9.html">深度学习之TensorFlow（一）&mdash;&mdash;基本使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve74o19.html">BigDecimal常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2jxx08.html">Java动态代理--&amp;gt&semi;Spring AOP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl2x5z9.html">java &commat;XmlTransient与&commat;Transient区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql161g19.html">回顾RAC安装过程中对ASM的处理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8mjr1p8.html">IIS&plus;域组策略&plus;hosts：禁止访问指定网站</a>
			</li>
						<li><a href="https://www.batexi.com/a/4953ne68.html">&lbrack;很郁闷&rsqb;python2&period;7连接mysql5&period;5配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2kvdlq.html">C&num;基础-事件 继承类无法直接引发基类的事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1v2z4q.html">&lbrack;WPF系列&rsqb;-基础系列　TabControl应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx2xde8.html">报表软件JS开发引用HTML DOM的windows对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jmg1g9.html">FineReport根据点击次数奇偶性排序之字符型</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnnk43q.html">required string parameter XXX is not present</a>
			</li>
						<li><a href="https://www.batexi.com/a/m963k2v9.html">POJ1275 Cashier Employment&lbrack;差分约束系统 &vert;&vert; 单纯形法&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwlpyr9.html">ASP&period;NET CORE dotnet run 命令使用debug方式运行</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ko6g5q.html">IntelliJ IDEA 乱码解决方案 （项目代码、控制台等）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
